<template>
  <Dialog :title="dialogTitle" v-model="dialogVisible">
    <el-form
      ref="formRef"
      :model="formData"
      :rules="formRules"
      label-width="100px"
      v-loading="formLoading"
    >
      <el-form-item label="图标名称" prop="modelName">
        <el-input v-model="formData.modelName" placeholder="请输入图标名称" />
      </el-form-item>
      <el-form-item label="图标路径" prop="modelPath">
        <el-input v-model="formData.modelPath" placeholder="请输入图标路径" />
      </el-form-item>
      <el-form-item label="图标图片" prop="imagePath">
        <UploadImg v-model="formData.imagePath" />
      </el-form-item>
      <el-form-item label="图标缩略图" prop="thumbnailPath">
        <UploadThumbnail v-model="formData.thumbnailPath" />
      </el-form-item>
      <el-form-item label="图标描述" prop="description">
        <el-input
          type="textarea"
          :rows="2"
          placeholder="请输入内容"
          v-model="formData.description"/>
      </el-form-item>
      <el-form-item label="图标状态" prop="status">
        <el-select v-model="formData.status" placeholder="请选择图标状态">
          <el-option
            v-for="dict in getIntDictOptions(DICT_TYPE.COMMON_STATUS)"
            :key="dict.value"
            :label="dict.label"
            :value="dict.value"
          />
        </el-select>
      </el-form-item>
      <el-form-item label="是否为公共模型" prop="tenantId">
        <el-radio-group v-model="formData.tenantId" class="!w-240px">
          <el-radio :label="0">是</el-radio>
          <el-radio :label="1">否</el-radio>
        </el-radio-group>
      </el-form-item>
    </el-form>
    <template #footer>
      <el-button @click="submitForm" type="primary" :disabled="formLoading">确 定</el-button>
      <el-button @click="dialogVisible = false">取 消</el-button>
    </template>
  </Dialog>
</template>
<script setup lang="ts">
import { getIntDictOptions, DICT_TYPE } from '@/utils/dict'
import { TwinModelIconApi, TwinModelsVO } from '@/api/gismodel/twinmodelicon'
/** 模型管理 表单 */
defineOptions({ name: 'TwinModelsForm' })



const { t } = useI18n() // 国际化
const message = useMessage() // 消息弹窗

const dialogVisible = ref(false) // 弹窗的是否展示
const dialogTitle = ref('') // 弹窗的标题
const formLoading = ref(false) // 表单的加载中：1）修改时的数据加载；2）提交的按钮禁用
const formType = ref('') // 表单的类型：create - 新增；update - 修改
const formData = ref({
  id: undefined,
  modelName: undefined,
  modelPath: undefined,
  imagePath: undefined,
  thumbnailPath: undefined,
  description: undefined,
  status: undefined,
  tenantId: undefined,
})
const formRules = reactive({
})
const formRef = ref() // 表单 Ref

/** 打开弹窗 */
const open = async (type: string, id?: number) => {
  dialogVisible.value = true
  dialogTitle.value = t('action.' + type)
  formType.value = type
  resetForm()
  // 修改时，设置数据
  if (id) {
    formLoading.value = true
    try {
      formData.value = await TwinModelIconApi.getTwinModels(id)
    } finally {
      formLoading.value = false
    }
  }
}
defineExpose({ open }) // 提供 open 方法，用于打开弹窗

/** 提交表单 */
const emit = defineEmits(['success']) // 定义 success 事件，用于操作成功后的回调
const submitForm = async () => {
  // 校验表单
  await formRef.value.validate()
  // 提交请求
  formLoading.value = true
  try {
    const data = formData.value as unknown as TwinModelsVO
    if (formType.value === 'create') {
      await TwinModelIconApi.createTwinModels(data)
      message.success(t('common.createSuccess'))
    } else {
      await TwinModelIconApi.updateTwinModels(data)
      message.success(t('common.updateSuccess'))
    }
    dialogVisible.value = false
    // 发送操作成功的事件
    emit('success')
  } finally {
    formLoading.value = false
  }
}

/** 重置表单 */
const resetForm = () => {
  formData.value = {
    id: undefined,
    modelName: undefined,
    modelPath: undefined,
    imagePath: undefined,
    thumbnailPath: undefined,
    description: undefined,
    status: undefined,
    tenantId: undefined,
  }
  formRef.value?.resetFields()
}

</script>
